*  Program...........: FAXBAT.PRG
*  Author............: Edward Leafe
*  Project...........:
*  Created...........: 08/11/94
*  Copyright.........: (c) 1994 Edward Leafe
*) Description.......: Demos sending multiple faxes in one transmission
*                      The basic idea is to print the reports separately
*                      to the WinFoxPro driver, giving them a send date
*                      way in the future. This will create fax image files
*                      in the C:\WINFAX\DATA directory (if WFP is installed
*                      on C:). The time at the beginning and end of the
*                      printing is recorded. ADIR is then used to get a list
*                      of all the fax image files. The array is then scanned
*                      to pick out only those that fall within the time noted
*                      during the printing. The real fax # is then poked, and
*                      these fax images are then sent as attachments. The
*                      undocumented DDE call to SendfaxUI is run to initiate
*                      transmission of the batched reports.
*  Calling Samples...:
*  Parameters........:
*  Major change list.:
PRIVATE ALL LIKE j*

* Record the beginning time
jcTime1 = TIME()

* Open the DDE channel to WinFaxPro
lnChan = DDEInitiate("FAXMNG", "TRANSMIT")
=DDEExecute(lnChan,"GoIdle")       && Idle the fax program

jcDummyNum = "5551212                && Dummy number   

* Run the reports you need. You need to poke the dummy fax info 
* before each report.
jcRun = '=DDEPoke(lnChan,"Sendfax",[recipient("' + jcDummyNum + ;
   '","23:59:59","12/31/99","DUMMY","","DUMMY SUBJECT")])'
&jcRun
REPORT FORM JUNK.FRX TO PRINT NOCO

&jcRun
REPORT FORM JUNK.FRX TO PRINT NOCO

&jcRun
REPORT FORM JUNK.FRX TO PRINT NOCO

* Record the ending time
jcTime2 = TIME()

* Now poke the real fax info
jcRealNum = "12013973041"
jcRun = '=DDEPoke(lnChan,"Sendfax",[recipient("' + jcRealNum + ;
   '","","","REAL","","REAL SUBJECT")])'
&jcRun

* Now check the WinFax\Data directory for fax image files that 
* were created between the times recorded above.
DIMENSION jaFaxFiles[1,5]
=ADIR(jaFaxFiles,"C:\WINFAX\DATA\*.FX?")
IF !EMPTY(jaFaxFiles[1,1])
   jnLen = ALEN(jaFaxFiles,1)
   FOR jnCnt = 1 TO jnLen
      IF (jaFaxFiles[jnCnt,3]=DATE()) AND (jaFaxFiles[jnCnt,4]>=jcTime1) ;
            AND (jaFaxFiles[jnCnt,4]<=jcTime2)
         * This is a file we need; attach it.
         jcFile = "C:\WINFAX\DATA\" + jaFaxFiles[jnCnt,1]
         jcRun = '=DDEPoke(lnChan,"Sendfax",[attach("' + jcFile + '")])'
         &jcRun
      ENDIF
   ENDFOR
ENDIF
* Now send the fax
=DDEExecute(lnChan,"GoActive")
=DDEExecute(lnChan,"SendfaxUI")
=DDETerminate(lnChan)





